module Cyclotomic (
                   cyclotomics,
                   cyclotomic,
                  ) where


import Polynomial

--- This is all there is to print the nth cyclotomic polynomial
-- all cyclotomic polynomials

cyclotomics = map cyclotomic [1..] 

-- returns the nth cyclotomic polynomial

cyclotomic n | n <= 1    = rth 1
             | otherwise = rmFactors (rth n) n 1 cyclotomics
             

rmFactors f n m (g:ms)  | m > n `div` 2 = f 
                        | m `divides` n = rmFactors (f `quotient` g) n (m+1) ms
                        | otherwise     = rmFactors f n (m+1) ms


rth r = (1 `xpower` r) : constPoly (-1) -- x^r - 1
divides x y = y `mod` x == 0   



