module Main (main) where

import System.Environment
import Cyclotomic
import Polynomial(showPoly)
import Data.List

main :: IO ()

printPolys = putStr . concat . intersperse "\n" . map showPoly
main = do args <- getArgs
          progname <- getProgName
          case args of
            []      -> printPolys cyclotomics
            (x:xs)  -> if x == "help" || x == "-h" || x == "--help" then
                           help progname
                       else
                           printPolys $ take (read x) cyclotomics
	  putStr "\n"

help p  = do putStr ("Usage: " ++ p ++ " [INTEGER|help|-h|--help]\n")
             putStr ("Prints the first n cyclotomic polynomials or the list of "
                    ++ "all cyclotomic polynomials if no arguments is given")
             